#define audiere_stream_load
// loads an audio file into memory for streaming
// argument0 = filename
// returns either an ID for use in all other functions or -1 if an error occurs

return external_call(global.dll_audiere_stream_load,argument0);
#define audiere_stream_load_xor
// loads an audio file from a crypted file into memory for streaming
// argument0 = filename
// argument1 = index
// returns either an ID for use in all other functions or -1 if an error occurs

return external_call(global.dll_audiere_stream_load_xor,argument0,argument1);
#define audiere_stream_unload
// frees the specified audio stream from memory
// argument0 = id

return external_call(global.dll_audiere_stream_unload,argument0);
#define audiere_stream_play
// starts playing the stream
// argument0 = id

return external_call(global.dll_audiere_stream_play,argument0);
#define audiere_stream_isplaying
// returns whether the stream is playing or not
// argument0 = id

return external_call(global.dll_audiere_stream_isplaying,argument0);
#define audiere_stream_pause
// pauses the stream
// argument0 = id

return external_call(global.dll_audiere_stream_pause,argument0);
#define audiere_stream_stop
// stops the stream setting the position to the beginning
// argument0 = id

return external_call(global.dll_audiere_stream_stop,argument0);
#define audiere_stream_get_position
// returns the current position in the stream in seconds
// argument0 = id

return external_call(global.dll_audiere_stream_get_position,argument0);
#define audiere_stream_set_position
// goes to the specified position in the stream in seconds
// argument0 = id
// argument1 = position

return external_call(global.dll_audiere_stream_set_position,argument0,argument1);
#define audiere_stream_get_length
// returns the length of the whole stream in seconds
// argument0 = id

return external_call(global.dll_audiere_stream_get_length,argument0);
#define audiere_stream_get_rate
// returns the sampling rate of the stream
// argument0 = id

return external_call(global.dll_audiere_stream_get_rate,argument0);
#define audiere_stream_get_repeat
// returns whether to repeat the stream or not
// argument0 = id

return external_call(global.dll_audiere_stream_get_repeat,argument0);
#define audiere_stream_set_repeat
// sets whether to repeat the stream or not
// argument0 = id
// argument1 = repeat (0 or 1)

return external_call(global.dll_audiere_stream_set_repeat,argument0,argument1);
#define audiere_stream_get_volume
// returns the current volume of the specified stream
// argument0 = id

return external_call(global.dll_audiere_stream_get_volume,argument0);
#define audiere_stream_set_volume
// sets the volume for the stream
// argument0 = id
// argument1 = volume (0 - 1)

return external_call(global.dll_audiere_stream_set_volume,argument0,argument1);
#define audiere_stream_get_pan
// returns the current pan of the stream
// argument0 = id

return external_call(global.dll_audiere_stream_get_pan,argument0);
#define audiere_stream_set_pan
// sets the pan for the stream
// argument0 = id
// argument1 = pan (-1 to 1)

return external_call(global.dll_audiere_stream_set_pan,argument0,argument1);
#define audiere_stream_get_pitch
// returns the speed of playing the stream
// argument0 = id

return external_call(global.dll_audiere_stream_get_pitch,argument0);
#define audiere_stream_set_pitch
// sets the speed of playing the stream
// argument0 = id
// argument1 = pitch factor (1 = normal)

return external_call(global.dll_audiere_stream_set_pitch,argument0,argument1);
#define audiere_stream_isseekable
// returns whether positioning in the stream is possible
// argument0 = id

return external_call(global.dll_audiere_stream_isseekable,argument0);
#define audiere_effect_load
// loads a sound effect into memory
// argument0 = filename
// returns either an ID for use in all other functions or -1 if an error occurs

return external_call(global.dll_audiere_effect_load,argument0);
#define audiere_effect_load_xor
// loads a sound effect from a crypted file into memory
// argument0 = filename
// argument1 = index
// returns either an ID for use in all other functions or -1 if an error occurs

return external_call(global.dll_audiere_effect_load_xor,argument0,argument1);
#define audiere_effect_unload
// frees the specified effect from memory
// argument0 = id

external_call(global.dll_audiere_effect_unload,argument0);
#define audiere_effect_play
// starts playing the effect
// argument0 = id

return external_call(global.dll_audiere_effect_play,argument0);
#define audiere_effect_stop
// stops playing the effect
// argument0 = id

return external_call(global.dll_audiere_effect_stop,argument0);
#define audiere_effect_get_volume
// returns the current volume of the specified effect
// argument0 = id

return external_call(global.dll_audiere_effect_get_volume,argument0);
#define audiere_effect_set_volume
// sets the volume for the effect
// argument0 = id
// argument1 = volume (0 - 1)

return external_call(global.dll_audiere_effect_set_volume,argument0,argument1);
#define audiere_effect_get_pan
// returns the current pan of the effect
// argument0 = id

return external_call(global.dll_audiere_effect_get_pan,argument0);
#define audiere_effect_set_pan
// sets the pan for the effect
// argument0 = id
// argument1 = pan (-1 to 1)

return external_call(global.dll_audiere_effect_set_pan,argument0,argument1);
#define audiere_effect_get_pitch
// returns the speed of playing the effect
// argument0 = id

return external_call(global.dll_audiere_effect_get_pitch,argument0);
#define audiere_effect_set_pitch
// sets the speed of playing the effect
// argument0 = id
// argument1 = pitch factor (1 = normal)

return external_call(global.dll_audiere_effect_set_pitch,argument0,argument1);
#define audiere_init
// argument0 = path to gma.dll
// argument1 = path to audiere.dll

if (!external_call(external_define(argument0,"audiere_init",dll_stdcall,ty_real,1,ty_string),argument1)) {
  external_free(argument0);
  return false;
}

global.dll_audiere_file = argument0;
global.dll_audiere_free = external_define(argument0,"audiere_free",dll_stdcall,ty_real,0);
global.dll_audiere_set_password = external_define(argument0,"audiere_set_password",dll_stdcall,ty_real,1,ty_string);

global.dll_audiere_stream_load = external_define(argument0,"audiere_stream_load",dll_stdcall,ty_real,1,ty_string);
global.dll_audiere_stream_load_xor = external_define(argument0,"audiere_stream_load_xor",dll_stdcall,ty_real,2,ty_string,ty_real);
global.dll_audiere_stream_unload = external_define(argument0,"audiere_stream_unload",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_play = external_define(argument0,"audiere_stream_play",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_isplaying = external_define(argument0,"audiere_stream_isplaying",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_pause = external_define(argument0,"audiere_stream_pause",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_stop = external_define(argument0,"audiere_stream_stop",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_get_position = external_define(argument0,"audiere_stream_get_position",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_set_position = external_define(argument0,"audiere_stream_set_position",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_stream_get_length = external_define(argument0,"audiere_stream_get_length",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_get_rate = external_define(argument0,"audiere_stream_get_rate",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_get_repeat = external_define(argument0,"audiere_stream_get_repeat",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_set_repeat = external_define(argument0,"audiere_stream_set_repeat",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_stream_get_volume = external_define(argument0,"audiere_stream_get_volume",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_set_volume = external_define(argument0,"audiere_stream_set_volume",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_stream_get_pan = external_define(argument0,"audiere_stream_get_pan",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_set_pan = external_define(argument0,"audiere_stream_set_pan",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_stream_get_pitch = external_define(argument0,"audiere_stream_get_pitch",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_stream_set_pitch = external_define(argument0,"audiere_stream_set_pitch",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_stream_isseekable = external_define(argument0,"audiere_stream_isseekable",dll_stdcall,ty_real,1,ty_real);

global.dll_audiere_effect_load = external_define(argument0,"audiere_effect_load",dll_stdcall,ty_real,1,ty_string);
global.dll_audiere_effect_load_xor = external_define(argument0,"audiere_effect_load_xor",dll_stdcall,ty_real,2,ty_string,ty_real);
global.dll_audiere_effect_unload = external_define(argument0,"audiere_effect_unload",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_play = external_define(argument0,"audiere_effect_play",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_stop = external_define(argument0,"audiere_effect_stop",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_get_volume = external_define(argument0,"audiere_effect_get_volume",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_set_volume = external_define(argument0,"audiere_effect_set_volume",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_effect_get_pan = external_define(argument0,"audiere_effect_get_pan",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_set_pan = external_define(argument0,"audiere_effect_set_pan",dll_stdcall,ty_real,2,ty_real,ty_real);
global.dll_audiere_effect_get_pitch = external_define(argument0,"audiere_effect_get_pitch",dll_stdcall,ty_real,1,ty_real);
global.dll_audiere_effect_set_pitch = external_define(argument0,"audiere_effect_set_pitch",dll_stdcall,ty_real,2,ty_real,ty_real);

return true;
#define audiere_free
external_call(global.dll_audiere_free);
external_free(global.dll_audiere_file);
#define audiere_set_password
// sets the password for decrypting audio files
// argument0 = password

return external_call(global.dll_audiere_set_password,argument0);
